import { createBlock } from '@modern-js-block/runtime';
import { Line } from '@antv/g2plot';
import { createChart } from "../base";
import { sortTimeData, compileFormatterStr, supportMultiYFields } from "../shared";
const LineChart = createChart(Line, {
  transformData: c => {
    const sortedData = sortTimeData(c);
    return supportMultiYFields(c, sortedData);
  },
  transformConfig: compileFormatterStr
});
export default createBlock({
  autoFit: true,
  renderer: 'svg',
  xField: 'x',
  yField: 'y',
  // yFields: ['y1', 'y2'],
  padding: 'auto',
  legend: {
    position: 'bottom',
    flipPage: false
  },
  lineStyle: {
    lineWidth: 1
  },
  legendPosition: 'bottom',
  legendSubPosition: 'left',
  // seriesField: 'series',
  xAxis: {},
  yAxis: {
    grid: {
      line: {
        style: {
          stroke: '#F2F3F5'
        }
      }
    }
  },
  tooltip: {
    shared: true
  },
  data: [{
    x: '2019-01',
    y1: 129,
    y2: 100
  }, {
    x: '2019-02',
    y1: 119,
    y2: 90
  }, {
    x: '2019-03',
    y1: 148,
    y2: 80
  }, {
    x: '2019-04',
    y1: 160,
    y2: 60
  }],
  title: '多折线图',
  subTitle: '一个简单的折线图'
})(LineChart);