"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _runtime = require("@modern-js-block/runtime");

var _g2plot = require("@antv/g2plot");

var _base = require("../base");

var _shared = require("../shared");

const BarChart = (0, _base.createChart)(_g2plot.Bar, {
  transformData: _shared.sortTimeData,
  transformConfig: _shared.compileFormatterStr
});

var _default = (0, _runtime.createBlock)({
  autoFit: true,
  renderer: 'svg',
  data: [],
  xField: 'x',
  yField: 'y',
  padding: 'auto',
  legend: {
    position: 'bottom',
    flipPage: false
  },
  lineStyle: {
    lineWidth: 1
  },
  xAxis: {},
  yAxis: {
    grid: {
      line: {
        style: {
          stroke: '#F2F3F5'
        }
      }
    }
  }
})(BarChart);

exports.default = _default;