"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _runtime = require("@modern-js-block/runtime");

var _g2plot = require("@antv/g2plot");

var _base = require("../base");

const HeatmapChart = (0, _base.createChart)(_g2plot.Heatmap, {
  transformData: options => {
    const {
      xField,
      data = [],
      isSorted
    } = options;

    if (isSorted) {
      return data.sort((a, b) => a[xField] - b[xField]);
    }

    return data;
  }
});

var _default = (0, _runtime.createBlock)({
  width: 650,
  height: 500,
  autoFit: false,
  data: [],
  xField: 'Month of Year',
  yField: 'District',
  colorField: 'AQHI',
  color: ['#174c83', '#7eb6d4', '#efefeb', '#efa759', '#9b4d16']
})(HeatmapChart);

exports.default = _default;