function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import { createBlock } from '@modern-js-block/runtime';
import { Funnel } from '@antv/g2plot';
import { createChart } from "../base";

var rateFormatter = function rateFormatter(v) {
  return "".concat((v * 100).toFixed(2), "%");
};

var conversionTag = {
  offsetX: 10,
  offsetY: 0,
  formatter: function formatter(datum) {
    var _ref = (datum === null || datum === void 0 ? void 0 : datum.compareNumber) || [1, 1],
        _ref2 = _slicedToArray(_ref, 2),
        pre = _ref2[0],
        curr = _ref2[1];

    return "\u8F6C\u5316\u7387".concat(rateFormatter(curr / pre));
  }
};
var label = {
  formatter: function formatter(_text, item) {
    return "".concat(item._origin.stage, " ").concat(item._origin.number);
  }
};
var tooltip = {
  customItems: function customItems(items) {
    return items.map(function (d) {
      return _objectSpread(_objectSpread({}, d), {}, {
        value: d.data.number
      });
    });
  }
};
var FunnelChart = createChart(Funnel, {
  transformData: function transformData(options) {
    var data = options.data,
        xField = options.xField,
        yField = options.yField; // 把数据统一转换为{ stage, number }

    var newData = (data === null || data === void 0 ? void 0 : data.map(function (it, idx) {
      var _data;

      return _objectSpread(_objectSpread({}, it), {}, {
        stage: data[idx][xField],
        number: Number(data[idx][yField]),
        compareNumber: [(data === null || data === void 0 ? void 0 : (_data = data[idx - 1]) === null || _data === void 0 ? void 0 : _data[yField]) || undefined, data[idx][yField]]
      });
    })) || []; // const total = newData?.reduce(
    //   (acc: number, it: Record<string, any>) => it.number + acc,
    //   0,
    // );

    if (newData && xField && yField) {
      newData === null || newData === void 0 ? void 0 : newData.forEach(function (it) {
        // it[yField] = Number(it[yField]);
        // it.totalNumber = total;
        it._number = 1;
      });
    }

    return newData || [];
  },
  transformConfig: function transformConfig(options) {
    var newOptions = _objectSpread(_objectSpread({}, options), {}, {
      yField: '_number',
      label: label,
      tooltip: tooltip,
      conversionTag: conversionTag
    });

    return newOptions;
  }
});
export default createBlock({
  xField: 'stage',
  yField: 'number',
  legend: false,
  data: [],
  title: '漏斗图',
  subTitle: '',
  dynamicHeight: true
})(FunnelChart);