import React from 'react';
import { Options } from '@antv/g2plot';
import { Axis } from '@antv/g2plot/lib/types/axis';
import { Tooltip } from '@antv/g2plot/lib/types/tooltip';
export declare type Data = Record<string, any>[];
export declare type ChartOptions = Omit<Options, 'data'> & {
  data?: Record<string, any>[];
  [key: string]: any;
};
export declare type ExtendFormatter = {
  formatterStr?: string;
};
export declare type ExtendAxis = Axis & {
  label?: {
    formatterStr?: string;
  };
};
export declare type SeqChartOptions<T extends Options> = Omit<T, 'data' | 'tooltip' | 'xAxis' | 'yAxis' | 'xField' | 'yField'> & {
  data?: Data;
  tooltip?: Tooltip & ExtendFormatter;
  xAxis?: ExtendAxis;
  yAxis?: ExtendAxis;
  xField?: string;
  yField?: string;
  yFields?: Array<string>;
  legendPosition?: string;
  legendSubPosition?: string;
  title?: string;
  subTitle?: string;
};
export declare type CreateChartOptions<T> = {
  transformData?: (options: T) => Data;
  transformConfig?: (options: T) => ChartOptions;
};
export declare type ChartType = any;
export declare const createChart: <TOptions extends ChartOptions>(Chart: ChartType, {
  transformData,
  transformConfig
}: CreateChartOptions<TOptions>) => React.MemoExoticComponent<(props: TOptions) => JSX.Element>;