import { createBlock } from '@modern-js-block/runtime';
import { Pie, PieOptions } from '@antv/g2plot';
import { createChart, Data } from '@/base';

export interface PieChartProps
  extends Omit<PieOptions, 'data' | 'angleField' | 'colorField'> {
  data?: Data;
  angleField?: string;
  colorField?: string;
}

const PieChart = createChart<PieChartProps>(Pie, {});

export default createBlock<PieChartProps>({
  autoFit: true,
  renderer: 'svg',
  angleField: 'value',
  colorField: 'type',
  radius: 0.8,
  padding: 'auto',
  label: {
    type: 'outer',
    content: '{name} {percentage} ({value})',
  },
  tooltip: {},
  interactions: [{ type: 'pie-legend-active' }, { type: 'element-active' }],
  data: [],
  legend: {},
})(PieChart);
