import React from 'react';
import { ColumnChart } from '@/index';

export const Empty = () => <ColumnChart />;

export const Basic = () => (
  <ColumnChart
    xField="type"
    yField="sales"
    xAxis={{
      label: {
        autoHide: true,
        autoRotate: false,
      },
    }}
    label={{
      // 可手动配置 label 数据标签位置
      position: 'middle', // 'top', 'bottom', 'middle',
      // 配置样式
      style: {
        fill: '#FFFFFF',
        opacity: 0.6,
      },
    }}
    meta={{
      type: {
        alias: '类别',
      },
      sales: {
        alias: '销售额',
      },
    }}
    data={[
      {
        type: '家具家电',
        sales: 38,
      },
      {
        type: '粮油副食',
        sales: 52,
      },
      {
        type: '生鲜水果',
        sales: 61,
      },
      {
        type: '美容洗护',
        sales: 145,
      },
      {
        type: '母婴用品',
        sales: 48,
      },
      {
        type: '进口食品',
        sales: 38,
      },
      {
        type: '食品饮料',
        sales: 38,
      },
      {
        type: '家庭清洁',
        sales: 38,
      },
    ]}
  />
);

export default { title: '柱状图' };
