import React, { useState, useEffect } from 'react';
import { HeatmapChart } from '@/index';

export const Heatmap = () => {
  const [data, setData] = useState([]);

  useEffect(() => {
    fetch(
      'https://gw.alipayobjects.com/os/basement_prod/a719cd4e-bd40-4878-a4b4-df8a6b531dfe.json',
    )
      .then(res => res.json())
      .then(data => setData(data));
  }, []);

  return (
    <HeatmapChart
      width={650}
      height={500}
      autoFit={false}
      data={data}
      xField="Month of Year"
      yField="District"
      colorField="AQHI"
      meta={{
        'Month of Year': {
          type: 'cat',
        },
      }}
      color={['#174c83', '#7eb6d4', '#efefeb', '#efa759', '#9b4d16']}
    />
  );
};

export default { title: '热力图' };
