import React from 'react';
import { LineChart } from '@/index';

export const Empty = () => <LineChart />;

export const Basic = () => (
  <LineChart
    padding="auto"
    xField="Date"
    yField="scales"
    xAxis={{
      type: 'timeCat',
      tickCount: 5,
    }}
    data={new Array(20).fill(0).map(_ => {
      return {
        Date: Date.now() - Math.random() * 24 * 3600 * 7 * 1000,
        scales: Math.round(Math.random() * 1000),
      };
    })}
  />
);

export const Series = () => (
  <LineChart
    padding="auto"
    xField="year"
    yField="value"
    seriesField="category"
    xAxis={{
      type: 'time',
    }}
    data={new Array(5).fill(0).reduce((buf, _, category) => {
      return buf.concat(
        new Array(20).fill(0).map((__, year) => {
          return {
            year: `20${year > 9 ? '' : '0'}${year}`,
            value: Math.round(Math.random() * 100),
            category: `Categroy ${category + 1}`,
          };
        }),
      );
    }, [])}
  />
);

export const MultiYFields = () => (
  <LineChart
    padding="auto"
    xField="year"
    yField="value"
    yFields={['value', 'value2']}
    seriesField="category"
    xAxis={{
      type: 'time',
    }}
    data={[
      {
        year: '1850',
        value: 0,
        value2: 2,
      },
      {
        year: '1890',
        value: 1,
        value2: 4,
      },
    ]}
  />
);

export const FormatterStr = () => (
  <LineChart
    padding="auto"
    xField="Date"
    yField="scales"
    xAxis={{
      type: 'timeCat',
      tickCount: 5,
      label: {
        formatterStr: '{value.slice(5)}',
      },
    }}
    yAxis={{
      label: {
        formatterStr: '{value/10}%',
      },
    }}
    tooltip={{
      formatterStr: '{y}M',
    }}
    data={new Array(20).fill(0).map(_ => {
      return {
        Date: Date.now() - Math.random() * 24 * 3600 * 7 * 1000,
        scales: Math.round(Math.random() * 1000),
      };
    })}
  />
);

export default { title: '折线图' };
